package com.my.config.dbConfig;

import java.io.InputStream;

import javax.annotation.Resource;

import org.springframework.boot.CommandLineRunner;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Component;

import com.my.config.dbConfig.ResponseParams;
import com.my.config.dbConfig.MyUtils;
import com.my.config.dbConfig.ExceptionUtils;


@Component
public class MyCommandLineRunner implements CommandLineRunner {

	@Resource
	private JdbcTemplateDao jdbcTemplateDao;

 /**实例化表，初始化之后记得注释此代码*/	@Override
	public void run(String... args) throws Exception {
		ResponseParams resp = new ResponseParams();
		String str = "";
		String[] sqlArr = null;
		try {
			ClassPathResource initTableResource = new ClassPathResource("initTables/initTable");
			InputStream inputStream = initTableResource.getInputStream();
			str = CommonUtils.streamToStr(inputStream);
			sqlArr = str.split(";");
			for (String sql : sqlArr) {
				jdbcTemplateDao.executeSql(sql);
			}
		} catch (Exception e) {
			ExceptionUtils.catchException(e, resp);
		}
		System.out.println(CommonUtils.jsonMapper.toJson(resp));
	}
}
