package com.my.utils;

import com.my.model.CommonException;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.servlet.http.HttpServletRequest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.HashMap;
import com.auth0.jwt.JWTSigner;
import com.auth0.jwt.JWTVerifier;
import com.fasterxml.jackson.databind.ObjectMapper;
import net.sf.json.JSONObject;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;public final class MyUtils {
	//密钥，修改成自己需要的密钥
	private static final String SECRET = "12346xx..@#%";
	
	private static final String PAYLOAD = "my_payload";
	
	private static final String EXP = "my_exp";
	
	private static final long MAXAGE =4600000000000L;
	public static final String STANDARD_FORMAT_ZERO = "yyyy-MM-dd HH:mm:ss.0";

	public static final String STANDARD_FORMAT_THREE_ZEROS = "yyyy-MM-dd HH:mm:ss.000";

	public static final String STANDARD_FORMAT = "yyyy-MM-dd HH:mm:ss";

	public static final String STANDARD_FORMAT_NO_SECOND = "yyyy-MM-dd HH:mm";

	public static final String DATE_FORMAT = "yyyy-MM-dd";

	public static final String DATE_FORMAT_YY_MM = "yyyyMM";

	public static final String DATE_FORMAT_YY_MM_DD = "yyyyMMdd";

	public static final String TIME_FORMAT = "HH:mm:ss";
 private static ObjectMapper mapper =new ObjectMapper();
 /**反序列化*/
	public static <T> T   fromJson(String jsonString, Class<T> clazz) {
		if (!isNotNull(jsonString)) {
			throw new CommonException(-1, "fromjson，参数不能为空！");
		}
		try {
			return mapper.readValue(jsonString, clazz);
		} catch (IOException e) {
			throw new CommonException(-1, e.getMessage());
		}
	} public static String toJson(Object object) {
		try {
			return mapper.writeValueAsString(object);
		} catch (JsonProcessingException e) {
			throw new CommonException(-1, e.getMessage());
		}
	}	public static String dateToStr(Date date, String formatStr) {
		if (date == null) {
			return null;
		}
		DateTime dateTime = new DateTime(date);
		return dateTime.toString(formatStr);
	}
	public static String dateToStr(Date date) {
		if (date == null) {
			return null;
		}
		DateTime dateTime = new DateTime(date);
		return dateTime.toString(STANDARD_FORMAT);
	}
    /**
     * get jwt String of object
     * @param object
     *            the POJO object
     * @param maxAge
     *            the milliseconds of life time
     * @return the jwt token
     */
    public static <T> String sign(T object,String secret) {
        try {
        	String userSecret = SECRET;
        	if(isNotNull(secret)) {
        		userSecret = secret;
        	}
            final JWTSigner signer = new JWTSigner(userSecret);
            final Map<String, Object> claimsMap = new HashMap<String, Object>();
            ObjectMapper mapper = new ObjectMapper();
            String jsonString = mapper.writeValueAsString(object);
            claimsMap.put(PAYLOAD, jsonString);
            long currentTimeMillis = System.currentTimeMillis();
            long exTimeMills = currentTimeMillis + MAXAGE;
            claimsMap.put(EXP, exTimeMills);//失效时间
            return signer.sign(claimsMap);
        } catch(Exception e) {
            return null;
        }
    }

	public static Date strToDate(String dateTimeStr) {
		DateTimeFormatter dateTimeFormatter = DateTimeFormat.forPattern(STANDARD_FORMAT);
		DateTime dateTime = null;
		try {
			dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
		} catch (IllegalArgumentException e) {
			try {
				dateTimeFormatter = DateTimeFormat.forPattern(STANDARD_FORMAT_NO_SECOND);
				dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
			} catch (IllegalArgumentException e1) {
				try {
					dateTimeFormatter = DateTimeFormat.forPattern(STANDARD_FORMAT_ZERO);
					dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
				} catch (IllegalArgumentException e2) {
					try {
						dateTimeFormatter = DateTimeFormat.forPattern(DATE_FORMAT);
						dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
					} catch (IllegalArgumentException e3) {
						try {
							dateTimeFormatter = DateTimeFormat.forPattern(TIME_FORMAT);
							dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
						} catch (Exception e4) {
							dateTimeFormatter = DateTimeFormat.forPattern(STANDARD_FORMAT_THREE_ZEROS);
							dateTime = dateTimeFormatter.parseDateTime(dateTimeStr);
						}
					}
				}
			}
		}
		return dateTime.toDate();
	}    /**
     * get the object of jwt if not expired
     * @param <T>
     * @param jwt
     * @return POJO object
     */
    public static <T> String unsign(String jwtJson, Class<T> classT,String secret) {
    	String userSecret = SECRET;
    	if(isNotNull(secret)) {
    		userSecret = secret;
    	}
    	final JWTVerifier verifier = new JWTVerifier(userSecret);
        try {
            final Map<String,Object> claims= verifier.verify(jwtJson);
            if (claims.containsKey(EXP) && claims.containsKey(PAYLOAD)) {
                long longExp = (Long)claims.get(EXP);
                long currentTimeMillis = System.currentTimeMillis();
                if (longExp > currentTimeMillis) {
                    String json = (String)claims.get(PAYLOAD);
                    //ObjectMapper objectMapper = new ObjectMapper();
                    //return objectMapper.readValue(json, classT);//表示可用
                    //return ErpStringUtil.jsonMapper.fromJson(json, classT);
                    return json;
                }else {
                	return "expire";
                }
            }else {
           	 	return "illegal";
           }
        } catch (Exception e) {
        	throw new CommonException(-1, "非法token:"+jwtJson);
        }
    }	public static boolean isNotNull(Object str) {
		if (str == null || str.toString().trim().length() == 0 || "".equals(str.toString().trim())) {
			return false;
		}
		return true;
	}

	public static boolean isNull(Object str) {
		return !isNotNull(str);
	}

	public static boolean isNull(Integer str) {
		return !isNotNull(str);
	}

	public static boolean isNotNull(Collection collection) {
		if (collection == null || collection.size() == 0) {
			return false;
		}
		return true;
	}

	public static boolean isNotNull(Map map) {
		if (map == null || map.size() == 0) {
			return false;
		}
		return true;
	}

	public static boolean isNotEmpty(Object str) {
		if (str != null && (str.toString().trim().length() == 0 || "".equals(str.toString().trim()))) {
			return true;
		}
		return false;
	}

	public static boolean isNotNull(Object[] arr) {
		if (arr == null || arr.length == 0) {
			return false;
		}
		return true;
	}

	public static boolean isNotNull(List<?> list) {
		if (list == null || list.size() == 0) {
			return false;
		}
		return true;
	}

	public static boolean isNull(List<?> list) {
		return !isNotNull(list);
	}

	public static boolean isNumeric(Object str) {
		return isInt(str) || isDouble(str);
	}

	public static boolean isNumeric(String str) {
		return isInt(str) || isDouble(str);
	}

	public static boolean isFieldMappingName(String str) {
		return Pattern.compile("^[A-Za-z-_]+$").matcher(str).find();
	}

	public static boolean isInt(Object str) {
		if (!isNotNull(str)) {
			return false;
		}
		return Pattern.compile("^-?[1-9]\\d*$").matcher(str.toString()).find();
	}

	public static boolean isDouble(Object str) {
		if (!isNotNull(str)) {
			return false;
		}
		return Pattern.compile("^-?([1-9]\\d*\\.\\d*|0\\.\\d*[1-9]\\d*|0?\\.0+|0)$").matcher(str.toString()).find();
	}

	/**
	 * @param dateStr
	 * @return 匹配年月日格式 1、年月日格式：2018-12-12
	 */
	public static boolean isDate(Object dateStr) {
		if (!isNotNull(dateStr)) {
			return false;
		}
		String format = "((19|20)[0-9]{2})[\\-\\:\\/\\_](0?[1-9]|1[012])[\\-\\:\\/\\_](0?[1-9]|[12][0-9]|3[01])";
		Pattern pattern = Pattern.compile(format);
		Matcher matcher = pattern.matcher(dateStr.toString());
		if (!matcher.matches()) {
			return false;
		}
		return true;
	}

	/**
	 * 匹配时间格式 1、时间格式：12:22:11
	 */
	public static boolean isTime(Object timeStr) {
		if (!isNotNull(timeStr)) {
			return false;
		}
		String format = "([01]?[0-9]|2[0-3])[\\-\\:\\/\\_][0-5][0-9][\\-\\:\\/\\_][0-5][0-9](\\.0)?";
		Pattern pattern = Pattern.compile(format);
		Matcher matcher = pattern.matcher(timeStr.toString());
		if (!matcher.matches()) {
			return false;
		}
		return true;
	}

	/**
	 * @param timeStr
	 * @return 匹配年月日时分秒格式 1、2019-12-22 12:12:33
	 */
	public static boolean isDateTime(Object dateTimeStr) {
		if (!isNotNull(dateTimeStr)) {
			return false;
		}
		String format = "((19|20)[0-9]{2})[\\-\\:\\/\\_](0?[1-9]|1[012])[\\-\\:\\/\\_](0?[1-9]|[12][0-9]|3[01])";
		format = format + " ([01]?[0-9]|2[0-3])[\\-\\:\\/\\_][0-5][0-9][\\-\\:\\/\\_][0-5][0-9](\\.0)?";
		Pattern pattern = Pattern.compile(format);
		Matcher matcher = pattern.matcher(dateTimeStr.toString());
		if (matcher.matches()) {
			pattern = Pattern.compile("(\\d{4})[\\-\\:\\/\\_](\\d+)[\\-\\:\\/\\_](\\d+).*");
			matcher = pattern.matcher(dateTimeStr.toString());
			if (matcher.matches()) {
				int y = Integer.valueOf(matcher.group(1));
				int m = Integer.valueOf(matcher.group(2));
				int d = Integer.valueOf(matcher.group(3));
				if (d > 28) {
					Calendar c = Calendar.getInstance();
					c.set(y, m - 1, 1);
					int lastDay = c.getActualMaximum(Calendar.DAY_OF_MONTH);
					return (lastDay >= d);
				} else {
					return true;
				}
			} else {
				return false;
			}
		} else {
			return false;
		}
	}}